/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
// d_zpoint.c: software driver module for drawing z-buffered points
/*********************************************************************
Copyright (c) 2001 Dan East
**********************************************************************

   Port of the original ID Software source code to Pocket PC,
   fixed point optimization, translation 
**********************************************************************
Copyright (c) 2006 Dr.Khumen Research Labs Ltd. 
          (c) 2006 Dmitry Gazko
**********************************************************************
   Port of PocketQuake source code to Symbian OS,
   fixed point translatation.       
**********************************************************************/


#include "quakedef.h"
#include "d_local.h"


/*
=====================
D_DrawZPoint
=====================
*/
#ifndef USEFPM
void D_DrawZPoint (void)
{
	byte	*pdest;
	short	*pz;
	int		izi;
	
	pz = d_pzbuffer + (d_zwidth * r_zpointdesc.v) + r_zpointdesc.u;
	pdest = d_viewbuffer + d_scantable[r_zpointdesc.v] + r_zpointdesc.u;
	izi = (int)(r_zpointdesc.zi * 0x8000);

	if (*pz <= izi)
	{
		*pz = izi;
		*pdest = r_zpointdesc.color;
	}
}
#endif
#ifdef USEFPM
void D_DrawZPointFPM (void)
{
	byte	*pdest;
	short	*pz;
	int		izi;
	
	pz = d_pzbuffer + (d_zwidth * r_zpointdescFPM.v) + r_zpointdescFPM.u;
	pdest = d_viewbuffer + d_scantable[r_zpointdescFPM.v] + r_zpointdescFPM.u;
	//Dan: Is this right?
	izi = FPM_TOLONG(FPM_MUL(r_zpointdescFPM.zi,FPM_FROMLONG(0x8000)));

	if (*pz <= izi)
	{
		*pz = izi;
		*pdest = r_zpointdescFPM.color;
	}
}
#endif